function EC_MO_correction
% One reference image - Source images are selected 
% Please note: this toolbox is still under construction and no disclaimer
% exist yet.
% S. Mohammadi (31/10/2011)

spm_defaults

% global default
% global k
% global VFmat VGmat zmin zmax VFd VFmat Nr zmed InterpLength;
% 
% 
% global freeze dummyOPT Maffine IN_freeze NoP Vdim_z indx_begin indx_end

global IN_freeze

dummy_freeze  = spm_input('Transformation paramters:',1,'m',...
          'individual|default phantom|default human', [0 1 2],3);
 
switch dummy_freeze
    case 0
        IN_freeze     =   spm_input('The Transformation Parameter');
    case 1
        IN_freeze = [ones(1,3) zeros(1,3) 0 1 0 1 1 0] ; 
    case 2
        IN_freeze = [ones(1,6) 0 1 0 1 1 0] ; 
end


% Nr  = length(find(IN_freeze>0));
% % Coregistration defaults
% % ACHTUNG DIESE FLAGS WERDEN NICHT BENUTZT -SIE MSSEN IN DER COREG
% % FUNCTION NOCHMAL GENDERT WERDEN - HIER NUR ZUR ILLUSTRATION
% %=======================================================================
% % defaults.coreg.estimate.cost_fun = 'nmi';
% defaults.coreg.estimate.sep      = [4 2];
% % defaults.coreg.estimate.tol      = [0.02 0.02 0.02 0.001 0.001 0.001 0.01 0.01 0.01 0.001 0.001 0.001];
% defaults.coreg.estimate.fwhm     = [7 4];
% % defaults.coreg.write.interp      = 4;
% defaults.coreg.write.wrap        = [0 0 0];
% defaults.coreg.write.mask        = 0;
%%%DEFAULTS
default_Vol = 15; 
dummy_write = 1;

% select the target image 
PG      = char(cfg_getfile(1,'img',['Target Images: b0 image']));
VG      = spm_vol(PG);
if(size(VG,1)~=size(PG,1))
    errror('You are using 4D image(s), data must be converted into 3D');
    for i=2:size(VG,1)
        [p, f, e]   = fileparts(VG(i).fname);
        if(i<=10)
            fname =[p filesep f '-0' num2str(i-1) deblank(e)];
            rP(i-1,1:length(fname))   = fname;
        else
            fname = [p filesep f '-' num2str(i-1) deblank(e)];
            rP(i-1,1:length(fname))   = fname;
        end
        rV(i-1)         = VG(i);
        rV(i-1).fname   = rP(i-1,:);
        rV(i-1).n       = [1 1];
        rV(i-1).n       = [1 1];
        rV(i-1).private.dat.dim = rV(i-1).dim;
        clear p f e fname;
    end
    VG      = VG(1);
else
        % Get Source Images
    rP      = char(cfg_getfile(Inf,'img',['Source Images: all other images'])) %
    rV      = spm_vol(rP(1:size(rP,1),:));
end

mireg    = struct('VG',[],'VF',[],'PO','');
% rename target
mireg.VG = spm_vol(VG);

[p,n,e] = fileparts(mireg.VG.fname);

% rename source(s)
mireg.VF = rV;

%%%%%%%%%%%%%% Coregister %%%%%%%%%%%%%%%%%%%%%%%%%
for j=1:size(mireg.VF,1),  
    fprintf('\nSource image: ');
    disp(mireg.VF(j).fname);
    fprintf('\n\nTarget image: ');
    disp(mireg.VG.fname);
    fprintf('\n\n\n');
    [p n e] =fileparts(rP(j,:));
    tmp = [p filesep 'mut_p2_' n '.mat'];
    Mfiles(j,1:numel(tmp)) = [p filesep 'mut_p2_' n '.mat'];
    params(:,j) = spm_coreg_freeze_v01(mireg.VG, mireg.VF(j));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if(dummy_write)
    EC_MO_write_rFiles(Mfiles,mireg,deblank(e));
end
disp('All diffusion weighted images coregistered to B0')


%-----------------------------------------------------------%
function [y1, y2, y3] = matr_mult (A, x1, x2, x3)

y1=A(1,1)*x1+A(1,2)*x2+A(1,3)*x3+A(1,4);
y2=A(2,1)*x1+A(2,2)*x2+A(2,3)*x3+A(2,4);
y3=A(3,1)*x1+A(3,2)*x2+A(3,3)*x3+A(3,4);

%- write data -------------------
function write_data(vol1,V,prefix,ending)
[pth,fname,ext] = fileparts(V.fname);
if(~exist('ending'))
    V.fname=[pth filesep prefix fname ext];
else
    V.fname=[pth filesep prefix fname ending ext];
end
spm_write_vol(V, vol1);

